﻿* Encoding: UTF-8.
*Compare proportions
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_AMONGCATS*/vers1***************************************************************************.
define !KO_amongcats(catvar= !charend('/') /binvars= !charend('/') /grvar= !charend('/') /missing= !charend('/') /none= !charend('/')
                    /test= !charend('/') /omnibus= !charend('/') /alpha= !charend('/') /adjust= !charend('/') /style= !charend('/')
                    /showsig= !charend('/') /merge= !charend('/') /sort= !charend('/') /format= !charend('/') /print= !charend('/')
                    /ci= !charend('/') /cibonf= !charend('/') /barchart= !charend('/') /graph= !charend('/') /save= !charend('/')
                    /dataset= !charend('/') !default('RENAME') /mxsize= !charend('/') !default(25))
title '!KO_AMONGCATS'.
!if (!print='YES') !then
-echo ''.
-echo '**** COMPARISON BETWEEN PROPORTIONS OF (POSITIVE RESPONSE) CATEGORIES ****'.
!ifend
!let !ok= 1
!if (!catvar<>!null !and !binvars<>!null !or !catvar=!null !and !binvars=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Either both or none of CATVAR and BINVARS subcommands specified.'.
!else !if (!binvars<>!null) !then !let !nvars= !null !let !vlist2= !null !let !vlist3= !null
 !do !w !in (!binvars)
  !let !nvars= !conc(!nvars,' ') !let !vlist2= !conc(!vlist2,',',!w) !let !vlist3= !conc(!vlist3,'+',!w)
 !doend !let !nvars= !len(!nvars) !let !vlist2= !tail(!vlist2) !let !vlist3= !tail(!vlist3)
 !if (!nvars=1 !or !len(!nvars)>2 !and !nvars<>100) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Number of BINVARS variables is <2 or >100.'
 !ifend
!else !if (!tail(!catvar)<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. More than one CATVAR variable specified.'.
!ifend !ifend !ifend
!if (!grvar<>!null !and !sort<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. SORT and GRVAR subcommands are incompatible.'.
!else !if (!omnibus<>'YES' !and !test='ZD') !then !let !ok= 0
-echo ''.
-echo '>ERROR. TEST=ZD requires OMNIBUS=YES.'.
!else !if (!tail(!graph)<>!null !and !index(!graph,' WEIGHT')=0 !and !index(!graph,' LABEL')=0
      !or !head(!graph)='WEIGHT' !or !head(!graph)='LABEL') !then !let !ok= 0
-echo ''.
-echo '>ERROR. GRAPH is specified incorrectly.'.
!ifend !ifend !ifend
!if (!ci<>!null !and !head(!tail(!ci))<>'AC' !and !head(!tail(!ci))<>'J') !then !let !ok= 0
- echo ''.
- echo '>ERROR. CI must consist of the pair: conf. level and then keyword AC or J.'.
- echo '>Optional keyword NOTABLE may follow last.'.
!ifend
!if (!ok) !then
 !if (!missing<>!null !and !binvars<>!null) !then
- echo ''.
- echo '>WARNING. MISSING is ignored when BINVARS is specified.'.
 !else !if (!none<>!null !and !catvar<>!null) !then
- echo ''.
- echo '>WARNING. NONE is ignored when CATVAR is specified.'.
 !ifend !ifend
 !if (!style='APA' !and !showsig='YES') !then
- echo ''.
- echo '>WARNING. SHOWSIG=YES will be ignored, because STYLE=APA.'.
 !ifend
 !if (!graph<>!null !and !grvar<>!null) !then
- echo ''.
- echo '>WARNING. GRAPH is ignored when GRVAR is specified.'.
 !ifend
 !if (!binvars=!null) !then !let !bin= 0 !else !let !bin= 1 !ifend
 !if (!grvar=!null) !then !let !nstn= 0
 !else !let !nstn= 1 !let !nesterr= "print /'>(At least on one level of GRVAR variable.)'"
 !ifend
 !if (!print='YES') !then !let !prnt= 1 !else !let !prnt= 0 !ifend
 !if (!alpha=!null) !then !let !alph= 0.05 !else !let !alph= !alpha !ifend
 !if (!test='ZY' !or !test='EZY') !then
  !if (!bin) !then !let !ya= '-1+(n_=0)' !else !let !ya= '+.5' !ifend
 !ifend
 !if (!dataset='RENAME') !then
- dataset name KO_amongcats#$._.
 !ifend
-oms /select headings /destination viewer= no.
-dataset decl aggr$$$$$._ window= hidden.
-dataset decl matr$$$$$._ window= hidden.
 !if (!graph<>!null !and !grvar=!null) !then
- dataset decl edge$$$$$._ window= hidden.
 !ifend
 !if (!bin) !then !let !var= 'b$$$$$'
  !let !foot= 'variable' !let !foot2= 'variables' !let !foot3= 'Variables'
  !let !tablab= 'Frequencies of Positive Response' !let !tablab2= 'Comparison of Positive Response proportions'
  !let !graphlab= '"Positive Response percent"'
- set errors none.
- temp.
  !let !vlist= !binvars !let !cnt= !null !let !ijlist= !null
  !do !vi !in (!binvars) !let !vlist= !tail(!vlist)
   !do !vj !in (!vlist) !let !cnt= !conc(!cnt,' ') !let !cnt2= !len(!cnt)
    !let !igtj= !conc(igtj$$$$$,!cnt2) !let !jgti= !conc(jgti$$$$$,!cnt2)
-   comp !igtj= !vi and not !vj.
-   comp !jgti= !vj and not !vi.
    !let !ijlist= !conc(!ijlist,'+',!igtj,'+',!jgti)
   !doend
  !doend
- comp rsum2$$$$$= sum(!vlist2)**2.
- comp ncnst$$$$$= rsum2$$$$$>0 and rsum2$$$$$<!nvars**2.
- comp ntot$$$$$= 1.
- select if nmiss(!vlist2)=0 !if (!none='EXCLUDE') !then and any(1,!vlist2) !ifend !if (!nstn) !then and not miss(!grvar) !ifend.
- split file off.
- oms /select tables /if commands=['CTables'] subtypes=['Custom Table']
      /destination format= sav outfile= 'aggr$$$$$._' viewer= no /tag= 'omssav$$$$$'.
  !if (!nstn) !then
-  ctables /table !grvar [C] > (!vlist3 !ijlist +rsum2$$$$$+ncnst$$$$$+ntot$$$$$)
           [S] [sum 'n$$$$$' validn 'tot$$$$$']
           /categ vari= !grvar empty= exclude.
  !else
-  ctables /table (!vlist3 !ijlist +rsum2$$$$$+ncnst$$$$$+ntot$$$$$)
           [S] [sum 'n$$$$$' validn 'tot$$$$$'].         
  !ifend           
- omsend tag= ['omssav$$$$$'].
- set errors list.
- dataset activ aggr$$$$$._.
- rename vari !if (!nstn) !then (var2=!grvar) (var3=b$$$$$) !else (var1=b$$$$$) !ifend.
- var lab b$$$$$ 'Binary variables'.
- comp n$$$$$= rnd(n$$$$$).
- comp tot$$$$$= rnd(tot$$$$$).
  !if (!nstn) !then
-  match files /file= * /by nestvar /first= fst$$$$$.
-  do if fst$$$$$.
-   comp case$$$$$= 1.
-  else.
-   comp case$$$$$= case$$$$$+1.
-  end if.
-  leave case$$$$$.
  !else
-  comp case$$$$$= $casenum.
  !ifend
- do if case$$$$$<=!nvars.
-  comp nopos$$$$$= n$$$$$=0.
-  comp noneg$$$$$= n$$$$$>=tot$$$$$.
- end if.
- aggreg /out= * mode= addvari over= yes /nopos$$$$$= max(nopos$$$$$) /noneg$$$$$= max(noneg$$$$$).
- do if $casenum=1.
-  do if nopos$$$$$.
-   print /' ' /'>ERROR. Some of BINVARS variables contain no positive response.'.
-   !nesterr.
-   print /'>!KO_AMONGCATS is executed incorrectly.'.
-   comp n$$$$$= $sysmis.
-  end if.
-  do if noneg$$$$$.
-   print /' ' /'>ERROR. Some of BINVARS variables contain no negative response.'.
-   !nesterr.
    !if (!none='EXCLUDE') !then
-    print /'>That might be due to NONE=EXCLUDE.'.
    !ifend
-   print /'>!KO_AMONGCATS is executed incorrectly.'.
-   comp n$$$$$= $sysmis.
-  end if.
-  do if !alph<=0 or !alph>=1.
-   print /' ' /'>ERROR. Specified ALPHA is not in the range (0,1).'
          /'>!KO_AMONGCATS is executed incorrectly.'.
-   comp n$$$$$= $sysmis.
-  end if.
- end if.
 !else !let !var= !catvar
  !let !foot= 'category' !let !foot2= 'categories' !let !foot3= 'Categories'
  !let !tablab= 'Frequencies in Categories' !let !tablab2= 'Comparison of Category proportions'
  !let !graphlab= '"Category percent"'
- set errors none.
- temp.
  !if (missing='INCLUDE') !then
-  miss val !catvar ().
  !ifend
- select if not miss(!catvar) !if (!nstn) !then and not miss(!grvar) !ifend.
- aggreg /out= aggr$$$$$._ /break= !grvar !catvar /n$$$$$= n.
- set errors list.
- dataset activ aggr$$$$$._.
- comp n$$$$$= rnd(n$$$$$).
- select if n$$$$$>0.
- aggreg /out= * mode= addvari /break= !grvar /ncat$$$$$= n /tot$$$$$= sum(n$$$$$).
  !if (!nstn) !then
-  aggreg /out= * mode= addvari /break= !catvar /nlev$$$$$= n.
-  aggreg /out= * mode= addvari /nlmn$$$$$= min(nlev$$$$$) /nlmx$$$$$= max(nlev$$$$$).
-  do if $casenum=1.
-   do if nlmn$$$$$<>nlmx$$$$$.
-    print /' ' /'>ERROR. Number or list of nonempty categories in CATVAR variable'
           /'>is different on different levels of GRVAR variable.'
           /'>!KO_AMONGCATS is executed incorrectly.'.
-    comp n$$$$$= $sysmis.
-   end if.
-  end if.
  !ifend
- sort cases by ncat$$$$$ (d).
- do if $casenum=1.
-  do if ncat$$$$$>100.
-   print /' ' /'>ERROR. Number of categories in CATVAR variable >100.'.
-   !nesterr.
-   print /'>!KO_AMONGCATS is executed incorrectly.'.
-  end if.
- end if.
- sort cases by ncat$$$$$ (a).
- do if $casenum=1.
-  do if ncat$$$$$=1.
-   print /' ' /'>ERROR. Number of categories in CATVAR variable <2.'.
-   !nesterr.
-   print /'>!KO_AMONGCATS is executed incorrectly.'.
-   comp n$$$$$= $sysmis.
-  end if.
-  do if !alph<=0 or !alph>=1.
-   print /' ' /'>ERROR. Specified ALPHA is not in the range (0,1).'
          /'>!KO_AMONGCATS is executed incorrectly.'.
-   comp n$$$$$= $sysmis.
-  end if.
- end if.
 !ifend
-set mxloops 1E8.
-matrix.
-comp v$= {'v$$$#1._','v$$$#2._','v$$$#3._','v$$$#4._','v$$$#5._','v$$$#6._','v$$$#7._','v$$$#8._','v$$$#9._','v$$#10._',
           'v$$#11._','v$$#12._','v$$#13._','v$$#14._','v$$#15._','v$$#16._','v$$#17._','v$$#18._','v$$#19._','v$$#20._',
           'v$$#21._','v$$#22._','v$$#23._','v$$#24._','v$$#25._','v$$#26._','v$$#27._','v$$#28._','v$$#29._','v$$#30._',
           'v$$#31._','v$$#32._','v$$#33._','v$$#34._','v$$#35._','v$$#36._','v$$#37._','v$$#38._','v$$#39._','v$$#40._',
           'v$$#41._','v$$#42._','v$$#43._','v$$#44._','v$$#45._','v$$#46._','v$$#47._','v$$#48._','v$$#49._','v$$#50._',
           'v$$#51._','v$$#52._','v$$#53._','v$$#54._','v$$#55._','v$$#56._','v$$#57._','v$$#58._','v$$#59._','v$$#60._',
           'v$$#61._','v$$#62._','v$$#63._','v$$#64._','v$$#65._','v$$#66._','v$$#67._','v$$#68._','v$$#69._','v$$#70._',
           'v$$#71._','v$$#72._','v$$#73._','v$$#74._','v$$#75._','v$$#76._','v$$#77._','v$$#78._','v$$#79._','v$$#80._',
           'v$$#81._','v$$#82._','v$$#83._','v$$#84._','v$$#85._','v$$#86._','v$$#87._','v$$#88._','v$$#89._','v$$#90._',
           'v$$#91._','v$$#92._','v$$#93._','v$$#94._','v$$#95._','v$$#96._','v$$#97._','v$$#98._','v$$#99._','v$$#100_'}.
-comp w$= {'w$$$#1._','w$$$#2._','w$$$#3._','w$$$#4._','w$$$#5._','w$$$#6._','w$$$#7._','w$$$#8._','w$$$#9._','w$$#10._',
           'w$$#11._','w$$#12._','w$$#13._','w$$#14._','w$$#15._','w$$#16._','w$$#17._','w$$#18._','w$$#19._','w$$#20._',
           'w$$#21._','w$$#22._','w$$#23._','w$$#24._','w$$#25._','w$$#26._','w$$#27._','w$$#28._','w$$#29._','w$$#30._',
           'w$$#31._','w$$#32._','w$$#33._','w$$#34._','w$$#35._','w$$#36._','w$$#37._','w$$#38._','w$$#39._','w$$#40._',
           'w$$#41._','w$$#42._','w$$#43._','w$$#44._','w$$#45._','w$$#46._','w$$#47._','w$$#48._','w$$#49._','w$$#50._',
           'w$$#51._','w$$#52._','w$$#53._','w$$#54._','w$$#55._','w$$#56._','w$$#57._','w$$#58._','w$$#59._','w$$#60._',
           'w$$#61._','w$$#62._','w$$#63._','w$$#64._','w$$#65._','w$$#66._','w$$#67._','w$$#68._','w$$#69._','w$$#70._',
           'w$$#71._','w$$#72._','w$$#73._','w$$#74._','w$$#75._','w$$#76._','w$$#77._','w$$#78._','w$$#79._','w$$#80._',
           'w$$#81._','w$$#82._','w$$#83._','w$$#84._','w$$#85._','w$$#86._','w$$#87._','w$$#88._','w$$#89._','w$$#90._',
           'w$$#91._','w$$#92._','w$$#93._','w$$#94._','w$$#95._','w$$#96._','w$$#97._','w$$#98._','w$$#99._','w$$#100_'}.
-comp names= {'v#$#$#._','p#$#$#._','s#$#$#._',v$,w$}.
-release v$,w$.
 !if (!bin) !then
- comp k= !nvars.
- get aggr /var= n$$$$$.
  !if (!nstn) !then
-  comp @k= k**2+3.
-  comp aggr= reshape(aggr,nrow(aggr)/@k,@k).
-  comp stpos= t(1:(k*nrow(aggr)):k).
  !else 
-  comp aggr= t(aggr).
-  comp stpos= 1.
  !ifend
- comp vv= aggr(:,1:k).
- comp vv= reshape(vv,nrow(vv)*k,ncol(vv)/k).
- comp ntot= aggr(:,ncol(aggr)).
- comp ncnst= aggr(:,ncol(aggr)-1).
- comp rsum2= aggr(:,ncol(aggr)-2).
- comp aggr= aggr(:,(k+1):(ncol(aggr)-3)).
- comp v10= aggr(:,1:ncol(aggr):2).
- comp v01= aggr(:,2:ncol(aggr):2).
- release aggr.
 !else
- get vv /var= n$$$$$.
- comp stpos= 1.
  !if (!nstn) !then
-  get nest /var= !grvar.
-  loop i= 2 to nrow(nest).
-   do if nest(i)<>nest(i-1).
-    comp stpos= {stpos;i}.
-   end if.
-  end loop.
-  comp k= nrow(nest)/nrow(stpos).
  !else
-  comp k= nrow(vv).
  !ifend
 !ifend
-comp ind= 1:k.
-do if k<=26.
- comp v2= {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'}(1:k).
-else.
- comp v2= {'AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ',
            'BA','BB','BC','BD','BE','BF','BG','BH','BI','BJ','BK','BL','BM','BN','BO','BP','BQ','BR','BS','BT','BU','BV','BW','BX','BY','BZ',
            'CA','CB','CC','CD','CE','CF','CG','CH','CI','CJ','CK','CL','CM','CN','CO','CP','CQ','CR','CS','CT','CU','CV','CW','CX','CY','CZ',
            'DA','DB','DC','DD','DE','DF','DG','DH','DI','DJ','DK','DL','DM','DN','DO','DP','DQ','DR','DS','DT','DU','DV'}(1:k).
-end if.
 !if (!style='APA') !then
- comp apav= {'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
              'aa','ab','ac','ad','ae','af','ag','ah','ai','aj','ak','al','am','an','ao','ap','aq','ar','as','at','au','av','aw','ax','ay','az',
              'ba','bb','bc','bd','be','bf','bg','bh','bi','bj','bk','bl','bm','bn','bo','bp','bq','br','bs','bt','bu','bv','bw','bx','by','bz',
              'ca','cb','cc','cd','ce','cf','cg','ch','ci','cj','ck','cl','cm','cn','co','cp','cq','cr','cs','ct','cu','cv'}(1:k).
 !ifend
 !if (!prnt) !then
  !if (!bin) !then
-  print /title 'Set of Binary Variables (multiple response) are analyzed.'.
-  print /title 'Pairwise comparison test to be done is'.
   !if (!test='ZD') !then
-   print /title "Paired-samples Proportions post-hoc test" /space= 0.
-   print /title "based on Dunn's approach," /space= 0.
-   print /title 'with Asymptotic (Normal Z) significance.' /space= 0.
   !else
-   print /title "Paired-samples Proportions (McNemar's) test" /space= 0.
    !if (!test='Z') !then
-    print /title 'with Asymptotic (Normal Z) significance.' /space= 0.
    !else !if (!test='ZY') !then
-    print /title 'with Asymptotic (Yates corrected Normal Z) significance' /space= 0.
    !else !if (!test='EZY') !then
-    print /title 'with Exact (Binomial) significance (for Mismatch N<=25) or' /space= 0.
-    print /title 'with Asymptotic (Yates corrected Normal Z) significance' /space= 0.
-    print /title '(for Mismatch N>25).' /space= 0.
    !else
-    print /title 'with Exact (Mid-p corrected Binomial) significance (for Mismatch N<=25) or' /space= 0.
-    print /title 'with Asymptotic (Normal Z) significance (for Mismatch N>25).' /space= 0.
    !ifend !ifend !ifend
   !ifend
   !if (!omnibus='YES') !then
-   print /title "Omnibus Cochran's Q test of equality of all related-samples proportions".
-   print /title 'will be done before pairwise testing.' /space= 0.
   !ifend
  !else
-  print /title 'One Categorical Variable (single response) is analyzed.'.
-  print /title 'Pairwise comparison test to be done is'.
   !if (!test='ZD') !then
-   print /title "One-sample Proportions post-hoc test" /space= 0.
-   print /title "based on Dunn's approach," /space= 0.
-   print /title 'with Asymptotic (Normal Z) significance.' /space= 0.
   !else
-   print /title 'One-sample Proportions (Binomial) test' /space= 0.
    !if (!test='Z') !then
-    print /title 'with Asymptotic (Normal Z) significance.' /space= 0.
    !else !if (!test='ZY') !then
-    print /title 'with Asymptotic (Yates corrected Normal Z) significance' /space= 0.
    !else !if (!test='EZY') !then
-    print /title 'with Exact (Binomial) significance (for Combined N<=25) or' /space= 0.
-    print /title 'with Asymptotic (Yates corrected Normal Z) significance' /space= 0.
-    print /title '(for Combined N>25).' /space= 0.
    !else
-    print /title 'with Exact (Mid-p corrected Binomial) significance (for Combined N<=25) or' /space= 0.
-    print /title 'with Asymptotic (Normal Z) significance (for Combined N>25).' /space= 0.
    !ifend !ifend !ifend
   !ifend
   !if (!omnibus='YES') !then
-   print /title 'Omnibus Chi-square one-sample test of equality of all categories'.
-   print /title 'will be done before pairwise testing.' /space= 0.
   !ifend
  !ifend
 !ifend
 !if (!test='EMZ' !or !test=!null !or !test='EZY') !then
- comp f= 1:25.
- loop i= 2 to 25.
-  comp f(i)= f(i-1)*f(i).
- end loop.
 !ifend
-loop gr= 1 to nrow(stpos).
  !if (!nstn) !then
-  comp v= vv(ind).
   !if (!prnt) !then
-   print /title '--------------------'.
-   print gr /title 'ANALYSIS in group #'.
-   print /title !quote(!conc('of the grouping variable ',!grvar,' ...')) /space= 0.
   !ifend
  !else
-  comp v= vv.
  !ifend
- comp nums= t(1:k).
  !if (!sort<>!null) !then
-  comp srnk= grade(!if (!sort='D') !then - !ifend v).
-  comp nums= nums(srnk).
-  comp v2= v2(srnk).
  !ifend
  !if (!bin) !then
-  comp pct= v/ntot(gr)*100.
   !if (!prnt) !then
-   print {t(1:k),v,pct} /title= 'Frequencies of positive response in variables:' /rnam= v2 /clab= 'Var.#' 'Count' 'Percent' /format= f8.2.
-   print ntot(gr) /title 'Total N:' /format= f10 /space= 0.
   !ifend
  !else
-  comp pct= v/msum(v)*100.
   !if (!prnt) !then
-   print {t(1:k),v,pct} /title= 'Frequencies in categories:' /rnam= v2 /clab= 'Cat.#' 'Count' 'Percent' /format= f8.2.
-   print msum(v) /title 'Total N:' /format= f10 /space= 0.
   !ifend
  !ifend
- comp ncmpr= k*(k-1)/2.
- comp pwsig= make(k,100,-1).
- comp pwsig2= make(k,100,' ').
  !if (!omnibus='YES') !then
   !if (!bin) !then !let !omtit= "Omnibus Cochran's Q test of equality of all k related-sample proportions:"
-   do if ncnst(gr)<4 or ncnst(gr)*k<24.
-    print ncnst /title ">WARNING. Number of cases N' having both positive and negative response" /format= f8.1.
-    print /title ">is <4 or N'*k (k is the number of variables) is <24" /space= 0.
-    print /title '>in the omnibus Q test. Take its result with care.' /space= 0.
     !if (!nstn) !then
-     print gr /title '>(group # of the grouping variable)' /space= 0.
     !ifend
-   end if.
-   comp sumv= msum(v).
-   comp denom= k*sumv-rsum2(gr).
-   comp chs= (k-1)*(k*mssq(v)-sumv&**2)/(denom+(denom=0)).
   !else !let !omtit= 'Omnibus Chi-square test of equality of all k category proportions:'
-   comp ef= csum(v)/k.
-   do if ef<5.
-    print ef /title '>WARNING. The expected count' /format= f8.1.
-    print /title '>is <5 in the omnibus Chi-square test. Take its result with care.' /space= 0.
     !if (!nstn) !then
-     print gr /title '>(group # of the grouping variable)' /space= 0.
     !ifend
-   end if.
-   comp chs= cssq(v-ef)/ef.
-   comp denom= ef*ncmpr*2.
   !ifend
-  comp omsig= 1-chicdf(chs,k-1).
   !if (!prnt) !then
-   print omsig /title !quote(!omtit) /rlab= 'Sig.' /format= f10.5.
   !ifend
-  do if omsig<!alph.
    !if (!prnt) !then
-    print /title 'Pairwise comparisons go next because the omnibus test is significant'.
-    print /title !quote(!conc('at ',!alph,' alpha level.')) /space= 0.
    !ifend
  !ifend
-   comp cnt= 0.
-   comp tsigs= make(ncmpr,3,0).
-   loop i= 1 to k-1.
-    loop j= i+1 to k.
-     comp cnt= cnt+1.
-     comp n= !if (!bin) !then v10(gr,cnt)+v01(gr,cnt) !else v(i)+v(j) !ifend.
-     do if n=0.
-      comp sig= 1.
-     else.
       !if (!test='EMZ' !or !test=!null !or !test='EZY') !then !let !endif= 'end if'
-       do if n<=25.
-        comp vmin= mmin !if (!bin) !then ({v10(gr,cnt),v01(gr,cnt)}) !else ({v(i),v(j)}) !ifend.
-        do if vmin=0.
-         comp cmb= 1.
-        else.
-         comp cmb= msum(f(n)/(f(1:vmin)&*f(n-(1:vmin))))+1.
-        end if.
-        comp sig= cmb*.5**n.
         !if (!test<>'EZY') !then
-         do if vmin=0.
-          comp sig= sig-.5*.5**n.
-         else.
-          comp sig= sig-.5*f(n)/(f(vmin)*f(n-vmin))*.5**n.
-         end if.
         !ifend
-       else.
       !ifend
         !if (!test='ZD') !then
-         comp z= abs(v(i)-v(j))*sqrt(ncmpr/denom).
-         comp sig= 1-cdfnorm(z).
         !else
          !if (!bin) !then
-          comp n_= v10(gr,cnt)-v01(gr,cnt).
-          comp z= (abs(n_) !ya)/sqrt(n).
-          comp sig= 1-cdfnorm(z).
          !else
-          comp z= (mmin({v(i),v(j)}) !ya -n*.5)/sqrt(n*.25).
-          comp sig= cdfnorm(z).
          !ifend
         !ifend
-       !endif.
-      comp sig= 2*sig.
-      do if sig>1.
-       comp sig= 1.
-      end if.
-     end if.
-     comp tsigs(cnt,:)= {i,j,sig}.
      !if (!prnt) !then
-      comp v2ij= {v2(i),v2(j)}.
       !if (!bin) !then
-       print {i,j} /title 'Variable pair' /cnam= v2ij /rlab= 'Var.#' /format= f4.
-       print {pct(i),pct(j)} /title 'Percents of positive response:' /format= f8.2 /space=0.
-       print ({v10(gr,cnt),v01(gr,cnt)}/(n+(n=0))*100) /title 'Mismatch percents in this pair:' /format= f8.2 /space=0.
-       print n /title 'Mismatch N:' /format= f10 /space=0.
       !else
-       print {i,j} /title 'Category pair' /cnam= v2ij /rlab= 'Cat.#' /format= f4.
-       print {pct(i),pct(j)} /title 'Percents among k categories:' /format= f8.2 /space=0.
-       print ({v(i),v(j)}/n*100) /title 'Percents in this pair:' /format= f8.2 /space=0.
-       print n /title 'Combined N:' /format= f10 /space=0.
       !ifend
-      print sig /title= '2-sided Sig.:' /format= f10.5 /space=0.
      !ifend
-    end loop.
-   end loop.
    !if (!adjust<>'NONE') !then
-    do if k>2.
-     comp sigs= tsigs(:,3).
      !if (!adjust='BH') !then
       !let !adjtit= 'Benjamini-Hochberg' !let !adjcapt= !conc('. With Benjamini-Hochberg correction (if k ',!foot2,' >2).')
-      comp rnk= grade(sigs).
-      comp sigs(rnk)= sigs.
-      comp indc= t(1:ncmpr)/ncmpr.
-      comp sigs_= sigs/indc.
-      loop i= ncmpr-1 to 1 by -1.
-       comp sigs_(i)= mmin({ncmpr/i*sigs(i),sigs_(i+1)}).
-      end loop.
-      comp sigs= sigs_(rnk).
      !else
       !let !adjtit= 'Bonferroni' !let !adjcapt= !conc('. With Bonferroni correction (if k ',!foot2,' >2).')
-      comp sigs= sigs*ncmpr.
      !ifend
-     comp sigs_= sigs<=1.
-     comp sigs= sigs&*sigs_+(not sigs_).
-     comp tsigs(:,3)= sigs.
      !if (!prnt) !then
-      print tsigs /title !quote(!conc(!adjtit,' corrected 2-sided Sig.:'))
          /clab= !if (!bin) !then 'Var.#' 'Var.#' !else 'Cat.#' 'Cat.#' !ifend 'Sig.' /format= f8.5.
      !ifend
-    end if.
    !else !let !adjcapt= '. Without correction for multiple comparisons.'
    !ifend
    !if (!style='APA') !then !let !domin= '"Subsets"'
-    comp sigsa= tsigs(:,3)>=!alph.
-    comp @adj= make(k,k,0).
-    comp @n= make(k,1,0).
-    loop i= 1 to nrow(tsigs).
-     do if sigsa(i).
-      comp @1= tsigs(i,1).
-      comp @2= tsigs(i,2).
-      comp @n(@1)= @n(@1)+1.
-      comp @n(@2)= @n(@2)+1.
-      comp @adj(@1,@n(@1))= @2.
-      comp @adj(@2,@n(@2))= @1.
-     end if.
-    end loop.
-    comp @adj(:,1)= @adj(:,1)+(@n=0)*(k+1).
-    comp @n= @n+(@n=0).
-    comp @rs= {0;0}.
-    comp @ps= {t(1:nrow(@adj));0}.
-    comp @xs= {0;0}.
-    comp @qs= {0;0}.
-    comp @ri= {1;0}.
-    comp @pi= {nrow(@adj);0}.
-    comp @xi= {1;0}.
-    comp @qi= {1;0}.
-    comp @cnt= 0.
-    loop if nrow(@rs)>1.
      !do !w !in ('@r @p @x @q') !let !ws= !conc(!w,'s') !let !wi= !conc(!w,'i')
-      comp !w= !ws(1:!wi(1)).
-      comp !ws= !ws((nrow(!w)+1):nrow(!ws)).
-      comp !wi= !wi(2:nrow(!wi)).
      !doend
-     do if not (any(@p) or any(@x)).
-      comp @cnt= @cnt+1.
-      comp pwsig2(@r,@cnt)= make(nrow(@r),1,apav(@cnt)).
-     else.
-      do if not any(@x).
-       comp @#= @p.
-      else if not any(@p).
-       comp @#= @x.
-      else.
-       comp @#= {@p;@x}.
-      end if.
-      comp @n#= @n(@#).
-      comp @i= mmax((@n#=mmax(@n#))&*t(1:nrow(@n#))).
-      comp @q= @#(@i).
-      comp @#= 0.
-      do if any(@p).
-       comp @nei= @adj(@q,1:@n(@q)).
-       loop @i= 1 to nrow(@p).
-        do if not any(@nei=@p(@i)).
-         comp @#= {@#;@p(@i)}.
-        end if.
-       end loop.
-       do if nrow(@#)>1.
-        comp @#= @#(2:nrow(@#)).
-       end if.
-      end if.
-      do if any(@#).
-       comp @v= @#(1).
-       comp @rs= {@r;@rs}.
-       comp @ri= {nrow(@r);@ri}.
-       do if nrow(@p)=1.
-        comp @#= 0.
-       else.
-        comp @#= mmax((@p=@v)&*t(1:nrow(@p))).
-        do if @#=1.
-         comp @#= @p(2:nrow(@p)).
-        else if @#= nrow(@p).
-         comp @#= @p(1:(nrow(@p)-1)).
-        else.
-         comp @#= @p({1:(@#-1),(@#+1):nrow(@p)}).
-        end if.
-       end if.
-       comp @ps= {@#;@ps}.
-       comp @pi= {nrow(@#);@pi}.
-       do if any(@x).
-        comp @#= {@x;@v}.
-       else.
-        comp @#= @v.
-       end if.
-       comp @xs= {@#;@xs}.
-       comp @xi= {nrow(@#);@xi}.
-       comp @qs= {@q;@qs}.
-       comp @qi= {1;@qi}.
-       do if any(@r).
-        comp @#= {@r;@v}.
-       else.
-        comp @#= @v.
-       end if.
-       comp @rs= {@#;@rs}.
-       comp @ri= {nrow(@#);@ri}.
-       comp @nei= @adj(@v,1:@n(@v)).
        !do !w !in('@p @x') !let !ws= !conc(!w,'s') !let !wi= !conc(!w,'i')
-        comp @#= 0.
-        do if any(!w).
-         loop @i= 1 to nrow(!w).
-          do if any(@nei=!w(@i)).
-           comp @#= {@#;!w(@i)}.
-          end if.
-         end loop.
-         do if nrow(@#)>1.
-          comp @#= @#(2:nrow(@#)).
-         end if.
-        end if.
-        comp !ws= {@#;!ws}.
-        comp !wi= {nrow(@#);!wi}.
        !doend
-       comp @qs= {@q;@qs}.
-       comp @qi= {1;@qi}.
-      end if.
-     end if.
-    end loop.
-    comp sigsa= not sigsa.
    !else !let !domin= '"Dominance"'
-    comp cnt= make(k,1,0).
-    comp igtj= v(tsigs(:,1))>v(tsigs(:,2)).
-    comp sigsa= tsigs(:,3)<!alph.
-    loop r= 1 to ncmpr.
-     do if sigsa(r).
-      comp i= tsigs(r,1).
-      comp j= tsigs(r,2).
-      comp sig= tsigs(r,3).
-      do if igtj(r).
-       comp cnt(i)= cnt(i)+1.
-       comp pwsig(i,cnt(i))= sig.
-       comp pwsig2(i,cnt(i))= v2(j).
-      else.
-       comp cnt(j)= cnt(j)+1.
-       comp pwsig(j,cnt(j))= sig.
-       comp pwsig2(j,cnt(j))= v2(i).
-      end if.
-     end if.
-    end loop.
    !ifend
  !if (!omnibus='YES') !then
-  else.
-   comp pwsig2(:,1)= make(k,1,'--').
    !if (!graph<>!null !and !grvar=!null) !then
-    comp tsigs= make(ncmpr,3,0).
-    comp cnt= 0.
-    loop i= 1 to k-1.
-     loop j= i+1 to k.
-      comp cnt= cnt+1.
-      comp tsigs(cnt,:)= {i,j,1}.
-     end loop.
-    end loop.
-    comp sigsa= make(ncmpr,1,-999).
    !ifend
    !if (!prnt) !then
-    print /title 'No pairwise comparisons are done because the omnibus test is nonsignificant'.
-    print /title !quote(!conc('at ',!alph,' alpha level.')) /space= 0.
    !ifend
-  end if.
  !ifend
- save {nums,pct,t(v2),pwsig,pwsig2} /out= matr$$$$$._ /names= names /string= s#$#$#._ w$$$#1._ to w$$#100_.
  !if (!graph<>!null !and !grvar=!null) !then
-  save {tsigs,sigsa} /out= edge$$$$$._ /vari= cat1 cat2 sigval sigflag.
  !ifend
 !if (!nstn) !then
-  comp ind= ind+k.
 !ifend
-end loop.
-end matrix.
-omsend.
 !if (!bin) !then
- select if case$$$$$<=!nvars.
 !ifend
-match files /file= * /file= matr$$$$$._.
-exec.
-string ww$$$$$ (a1000).
-vector v= v$$$#1._ to v$$#100_ /w= w$$$#1._ to w$$#100_.
-do if w$$$#1._='--'.
- comp ww$$$$$= '--'.
-else.
  !if (!style='APA') !then
-  loop #i= 1 to 100.
    do if w(#i)<>' '.
-    comp ww$$$$$= conc(ww$$$$$,',',w(#i)).
    end if.
-  end loop.
-  comp ww$$$$$= ltrim(ww$$$$$,',').
  !else
-  loop #i= 1 to 100 if v(#i)<>-1.
    !if (!showsig='YES') !then
-    comp w(#i)= conc(w(#i),'(',string(v(#i),f5.3),')').
    !ifend
-   comp ww$$$$$= conc(ww$$$$$,' ',w(#i)).
-  end loop.
-  comp ww$$$$$= ltrim(ww$$$$$).
  !ifend
-end if.
-comp s#$#$#._= conc('(',s#$#$#._,')').
-exec.
 !if (!ci<>!null) !then
  !let !clev= !head(!ci) !let !cilo= !conc(!clev,'%CI Lower') !let !cihi= !conc(!clev,'%CI Higher')
  !if (!cibonf='YES') !then
   !if (!bin) !then !let !cib= !conc('/',!nvars) !else !let !cib= '/(ncat$$$$$-1)' !ifend
   !let !cilo= !conc('[Bonf]',!cilo) !let !cihi= !conc('[Bonf]',!cihi)
   !let !bonfexp= ', Bonf.-expanded'
  !ifend
- comp #alpha= (100-!clev)/100.
  !if (!head(!tail(!ci))= 'AC') !then
-  comp #z= probit(1-#alpha/2 !cib).
-  comp #tot_= tot$$$$$+#z*#z.
-  comp #p_= (n$$$$$+#z*#z/2)/#tot_.
-  comp #se= sqrt(#p_*(1-#p_)/#tot_).
-  comp lo$$$$$= (#p_-#z*#se)*100.
-  comp hi$$$$$= (#p_+#z*#se)*100.
  !else
-  comp #shape1= n$$$$$+.5.
-  comp #shape2= tot$$$$$-n$$$$$+.5.
-  comp lo$$$$$= idf.beta(#alpha/2 !cib,#shape1,#shape2)*100.
-  comp hi$$$$$= idf.beta(1-#alpha/2 !cib,#shape1,#shape2)*100.
  !ifend
- if lo$$$$$<0 lo$$$$$= 0.
- if hi$$$$$>100 hi$$$$$= 100.
 !ifend
-format n$$$$$ (f8) p#$#$#._ !if (!ci<>!null) !then lo$$$$$ hi$$$$$ !ifend !if (!format=!null) !then (pct8.1) !else (!format) !ifend.
-var lab n$$$$$ 'Count' p#$#$#._ 'Percent' s#$#$#._ 'Key' !if (!ci<>!null) !then lo$$$$$ !quote(!cilo) hi$$$$$ !quote(!cihi) !ifend
   ww$$$$$ !if (!style='APA') !then 'Subsets of nonsignificance' !else 'Dominance over' !ifend.
 !if (!sort<>!null) !then
- sort cases by v#$#$#._.
 !ifend
-oms /select headings tables /if commands=['Summarize'] subtypes=['Case Processing Summary' 'Notes']
     /destination viewer= no.
 !if (!nstn) !then
- split file layered by !grvar.
 !ifend
 !if (!merge='YES') !then
- summar /tables= !var s#$#$#._ n$$$$$ p#$#$#._ !if (!ci<>!null !and !tail(!tail(!ci))<>' NOTABLE') !then lo$$$$$ hi$$$$$ !ifend ww$$$$$
    /format= list nocase notot /cells= none
    /title= !quote(!conc(!tablab,'\n& ',!tablab2))
    !if (!style='APA') !then
     /footnote= !quote(!conc('Results are based on two-sided tests. Alpha level: ',!alph,!adjcapt,
        '\nEach lo-case subscript is a subset of no signif. diff-ces inside. ',!foot3,' not sharing the same subscript are significantly different.')).
    !else
     /footnote= !quote(!conc('Results are based on two-sided tests. Alpha level: ',!alph,!adjcapt,
        '\nFor each significant pair, the key of the ',!foot,' with the smaller count appears in the ',!foot,' with the larger count.')).
    !ifend
 !else
- summar /tables= !var n$$$$$ p#$#$#._ !if (!ci<>!null !and !tail(!tail(!ci))<>' NOTABLE') !then lo$$$$$ hi$$$$$ !ifend
    /format= list nocase notot /cells= none
    /title= !quote(!tablab).
- summar /tables= !var s#$#$#._ ww$$$$$ /format= list nocase notot /cells= none
    /title= !quote(!tablab2)
    !if (!style='APA') !then
     /footnote= !quote(!conc('Results are based on two-sided tests. Alpha level: ',!alph,!adjcapt,
        '\nEach lo-case subscript is a subset of no signif. diff-ces inside. ',!foot3,' not sharing the same subscript are significantly different.')).
    !else
     /footnote= !quote(!conc('Results are based on two-sided tests. Alpha level: ',!alph,!adjcapt,
        '\nFor each significant pair, the key of the ',!foot,' with the smaller count appears in the ',!foot,' with the larger count.')).
    !ifend
 !ifend
 !if (!omnibus<>!null) !then
- echo '>NOTE: Pairwise tests were preceded by the omnibus test of equality of'.
- echo !quote(!conc(' all k ',!foot2,'. Key "--" in the ',!domin,' tells that no pairwise')).
- echo !quote(!conc(' testing was done, because the omnibus was nonsignificant at ',!alph,' level.')).
- echo ''.
 !ifend
 !if (!style='APA') !then
- echo '>NOTE. Capital letter "Key" has no relation to the subscripts "Subsets"'.
- echo !quote(!conc(' and is used to enumerate the ',!foot2,'.')).
 !ifend
-split file off.
-omsend.
 !if (!barchart='YES') !then
  !if (!bin) !then !let !catax= 'Binary variables' !else !let !catax= !catvar !ifend
- comp case$$$$$= $casenum.
- do if $casenum=1.
-  write outfile= 'temp_KO_amongcats.sps'
     /'SOURCE: s=userSource(id("graphdataset"))'
     /'DATA: cat=col(source(s),name("cat"),unit.category())'
     /'DATA: pct=col(source(s),name("pct"))'
     /'DATA: case=col(source(s),name("case"))'
    !if (!ci<>!null) !then !let !cifoot= !conc(!head(!ci),'% CI',!bonfexp)
     /'DATA: lo=col(source(s),name("lo"))'
     /'DATA: hi=col(source(s),name("hi"))'
     /!quote(!conc('GUIDE: text.footnote(label("',!cifoot,'"))'))
    !ifend
    !if (!nstn) !then !let !bygrvar= '*grvar'
     /'DATA: grvar=col(source(s),name("grvar"),unit.category())'
     /'GUIDE: axis(dim(3),label("groups"),opposite())'
     /'COORD: transpose(rect(dim(1,2),wrap()))'
    !else
     /'COORD: transpose()'
    !ifend
     /'GUIDE: axis(dim(2),label("%"))'
     /!quote(!conc('GUIDE: axis(dim(1),label("',!catax,'"))'))
     /'SCALE: cat(dim(1),sort.statistic(summary.first(case)),reverse())'
     /'SCALE: linear(dim(2),include(0))'
     /!quote(!conc('ELEMENT: interval(position(cat*pct',!bygrvar,'),shape.interior(shape.square))'))
    !if (!ci<>!null) !then
     /!quote(!conc('ELEMENT: interval(position(region.spread.range(cat*(lo+hi)',!bygrvar,')),shape(shape.ibeam))'))
    !ifend.
- end if.
- exec.
- GGRAPH
    /GRAPHDATASET NAME= "graphdataset" VARIABLES= !var[name="cat"] MEAN(p#$#$#._)[name="pct"] case$$$$$[name="case"]
     !if (!ci<>!null) !then MEAN(lo$$$$$)[name="lo"] MEAN(hi$$$$$)[name="hi"] !ifend
     !if (!nstn) !then !grvar[name="grvar"] !ifend
    /GRAPHSPEC SOURCE= GPLFILE('temp_KO_amongcats.sps').
- erase file 'temp_KO_amongcats.sps'.
 !ifend
 !if (!graph<>!null !and !grvar=!null) !then
  !if (!head(!graph)='NETWORK') !then !let !layout= 'network' 
  !else !if (!head(!graph)='GRID') !then !let !layout= 'grid'
  !else !let !layout= 'circle'
  !ifend !ifend
  !if (!index(!graph,'LABEL')>0) !then
   !let !edgelab= ',label(edgelab)' !let !edgelab2= 'Edge labels are p-values. '
  !ifend
- do if $casenum=1.
-  write outfile= 'temp_KO_amongcats.sps'
     /'SOURCE: edge=userSource(id("edge"))'
     /'SOURCE: vert=userSource(id("vert"))'
     /'DATA: fromvar=col(source(edge),name("cat1"),unit.category())'
     /'DATA: tovar=col(source(edge),name("cat2"),unit.category())'
     /'DATA: edgelab=col(source(edge),name("sigval"))'
     /'DATA: edgeclr=col(source(edge),name("sigflag"),unit.category())'
     /'DATA: vertid=col(source(vert),name("v#$#$#._"),unit.category())'
     /'DATA: vertlab=col(source(vert),name("s#$#$#._"),unit.category())'
     /'DATA: vertsize=col(source(vert),name("p#$#$#._"))'
     /'GUIDE: axis(dim(1),null())'
     /'GUIDE: axis(dim(2),null())'
     /'GUIDE: legend(aesthetic(aesthetic.color),label("Comparison result"))'
     /'GUIDE: legend(aesthetic(aesthetic.size),' !quote(!conc('label(',!graphlab,'))'))
     /!quote(!conc('GUIDE: text.footnote(label("',!edgelab2,'Alpha=',!alph,'."))'))
     /'SCALE: cat(aesthetic(aesthetic.color),map(("0",color.grey),("1",color.red),("-999",color.brown)))'
     /!quote(!conc('SCALE: linear(aesthetic(aesthetic.size),aestheticMinimum(size."5px"),aestheticMaximum(size."',!mxsize,'px"))'))
     /!quote(!conc('ELEMENT: edge(position(layout.',!layout,'(node(vertid),from(fromvar),to(tovar)))',!edgelab,',size(size."2px"),color(edgeclr))'))
     /!quote(!conc('ELEMENT: point(position(layout.',!layout,'(node(vertid)')) ',from(fromvar),to(tovar))),label(vertlab),size(vertsize))'.
- end if.
- exec.
- dataset activ edge$$$$$._.
- format sigval (f5.3) sigflag (f8).
- val lab sigflag 1 'significant' 0 'nonsignificant' -999 'no comparison (ns. omnibus)'.
  !if (!index(!graph,'WEIGHT')>1) !then
-  comp sigval2= lg10(sigval+.005)+2.5.
-  exec.
-  weight by sigval2.
  !ifend
- echo ''.
- echo !quote(!conc('GRAPH = ',!graph,':')).
- GGRAPH
    /GRAPHDATASET NAME= "edge" dataset= * VARIABLES= cat1 cat2 sigval sigflag
    /GRAPHDATASET NAME= "vert" dataset= matr$$$$$._ VARIABLES= v#$#$#._ p#$#$#._ s#$#$#._
    /GRAPHSPEC SOURCE= GPLFILE('temp_KO_amongcats.sps').
- erase file 'temp_KO_amongcats.sps'.
- dataset close edge$$$$$._.
- dataset activ aggr$$$$$._.
 !ifend
-dataset close matr$$$$$._.
 !if (!save<>!null) !then
- var lab tot$$$$$ 'Total N'.
- format tot$$$$$ (f8).
- save outfile= !save
    /keep= !grvar !var s#$#$#._ n$$$$$ tot$$$$$ p#$#$#._ !if (!ci<>!null) !then lo$$$$$ hi$$$$$ !ifend ww$$$$$.
- echo ''.
- echo 'Table of results was saved as data:'.
- echo !save.
 !ifend
-dataset close *.
 !if (!dataset='RENAME') !then
- dataset activ KO_amongcats#$._.
 !else !if (!dataset<>!null) !then
- dataset activ !dataset.
 !else
- echo ''.
- echo '>WARNING. DATASET subcommand was empty (unspecified).'.
- echo '>To make your input (working) dataset active, issue command'.
- echo '>DATASET ACTIVATE name, where "name" is the name of the dataset.'.
 !ifend !ifend
!else
-echo '>!KO_AMONGCATS is not executed.'.
!ifend
!enddefine.
